# Copyright 2014-2017 Intel Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.


from sys import version_info
if version_info >= (2, 6, 0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_ridge_regression', [dirname(__file__)])
        except ImportError:
            import _ridge_regression
            return _ridge_regression
        if fp is not None:
            try:
                _mod = imp.load_module('_ridge_regression', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _ridge_regression = swig_import_helper()
    del swig_import_helper
else:
    import _ridge_regression
del version_info
try:
    _swig_property = property
except NameError:
    pass  # Python < 2.2 doesn't have 'property'.


def _swig_setattr_nondynamic(self, class_type, name, value, static=1):
    if (name == "thisown"):
        return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name, None)
    if method:
        return method(self, value)
    if (not static):
        if _newclass:
            object.__setattr__(self, name, value)
        else:
            self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)


def _swig_setattr(self, class_type, name, value):
    return _swig_setattr_nondynamic(self, class_type, name, value, 0)


def _swig_getattr_nondynamic(self, class_type, name, static=1):
    if (name == "thisown"):
        return self.this.own()
    method = class_type.__swig_getmethods__.get(name, None)
    if method:
        return method(self)
    if (not static):
        return object.__getattr__(self, name)
    else:
        raise AttributeError(name)

def _swig_getattr(self, class_type, name):
    return _swig_getattr_nondynamic(self, class_type, name, 0)


def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object:
        pass
    _newclass = 0


import daal.algorithms
import daal.data_management
import daal
import daal.services
import daal.data_management.data_feature_utils
class ModelNormEq(daal.algorithms.Model):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Model]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ModelNormEq, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Model]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, ModelNormEq, name)
    __repr__ = _swig_repr
    __swig_getmethods__["serializationTag"] = lambda x: _ridge_regression.ModelNormEq_serializationTag
    if _newclass:
        serializationTag = staticmethod(_ridge_regression.ModelNormEq_serializationTag)

    def getSerializationTag(self):
        return _ridge_regression.ModelNormEq_getSerializationTag(self)

    def __init__(self):
        this = _ridge_regression.new_ModelNormEq()
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _ridge_regression.delete_ModelNormEq
    __del__ = lambda self: None

    def initialize(self):
        return _ridge_regression.ModelNormEq_initialize(self)

    def getXTXTable(self):
        return _ridge_regression.ModelNormEq_getXTXTable(self)

    def getXTYTable(self):
        return _ridge_regression.ModelNormEq_getXTYTable(self)
ModelNormEq_swigregister = _ridge_regression.ModelNormEq_swigregister
ModelNormEq_swigregister(ModelNormEq)

def ModelNormEq_serializationTag():
    return _ridge_regression.ModelNormEq_serializationTag()
ModelNormEq_serializationTag = _ridge_regression.ModelNormEq_serializationTag

def ModelNormEq_Float64(featnum, nrhs, par, dummy):
    val = _ridge_regression.new_ModelNormEq_Float64(featnum, nrhs, par, dummy)
    return val

def ModelNormEq_Float32(featnum, nrhs, par, dummy):
    val = _ridge_regression.new_ModelNormEq_Float32(featnum, nrhs, par, dummy)
    return val

class Parameter(daal.algorithms.Parameter):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Parameter]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Parameter, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Parameter]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Parameter, name)
    __repr__ = _swig_repr

    def __init__(self):
        this = _ridge_regression.new_Parameter()
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_setmethods__["interceptFlag"] = _ridge_regression.Parameter_interceptFlag_set
    __swig_getmethods__["interceptFlag"] = _ridge_regression.Parameter_interceptFlag_get
    if _newclass:
        interceptFlag = _swig_property(_ridge_regression.Parameter_interceptFlag_get, _ridge_regression.Parameter_interceptFlag_set)
    __swig_destroy__ = _ridge_regression.delete_Parameter
    __del__ = lambda self: None
Parameter_swigregister = _ridge_regression.Parameter_swigregister
Parameter_swigregister(Parameter)

class TrainParameter(Parameter):
    __swig_setmethods__ = {}
    for _s in [Parameter]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TrainParameter, name, value)
    __swig_getmethods__ = {}
    for _s in [Parameter]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, TrainParameter, name)
    __repr__ = _swig_repr

    def __init__(self):
        this = _ridge_regression.new_TrainParameter()
        try:
            self.this.append(this)
        except:
            self.this = this

    def check(self):
        return _ridge_regression.TrainParameter_check(self)
    __swig_setmethods__["ridgeParameters"] = _ridge_regression.TrainParameter_ridgeParameters_set
    __swig_getmethods__["ridgeParameters"] = _ridge_regression.TrainParameter_ridgeParameters_get
    if _newclass:
        ridgeParameters = _swig_property(_ridge_regression.TrainParameter_ridgeParameters_get, _ridge_regression.TrainParameter_ridgeParameters_set)
    __swig_destroy__ = _ridge_regression.delete_TrainParameter
    __del__ = lambda self: None
TrainParameter_swigregister = _ridge_regression.TrainParameter_swigregister
TrainParameter_swigregister(TrainParameter)

class Model(daal.algorithms.Model):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Model]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Model, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Model]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Model, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _ridge_regression.new_Model(*args)
        try:
            self.this.append(this)
        except:
            self.this = this

    def initialize(self):
        return _ridge_regression.Model_initialize(self)
    __swig_destroy__ = _ridge_regression.delete_Model
    __del__ = lambda self: None

    def getNumberOfBetas(self):
        return _ridge_regression.Model_getNumberOfBetas(self)

    def getNumberOfFeatures(self):
        return _ridge_regression.Model_getNumberOfFeatures(self)

    def getNumberOfResponses(self):
        return _ridge_regression.Model_getNumberOfResponses(self)

    def getInterceptFlag(self):
        return _ridge_regression.Model_getInterceptFlag(self)

    def getBeta(self, *args):
        return _ridge_regression.Model_getBeta(self, *args)
Model_swigregister = _ridge_regression.Model_swigregister
Model_swigregister(Model)

def Model_Float64(featnum, nrhs, par, dummy):
    val = _ridge_regression.new_Model_Float64(featnum, nrhs, par, dummy)
    return val

def Model_Float32(featnum, nrhs, par, dummy):
    val = _ridge_regression.new_Model_Float32(featnum, nrhs, par, dummy)
    return val


def checkModel(model, par, errors, coefdim, nrhs, method):
    return _ridge_regression.checkModel(model, par, errors, coefdim, nrhs, method)
checkModel = _ridge_regression.checkModel
from numpy import float64, float32, intc


# This file is compatible with both classic and new-style classes.


